/*
 * MosP - Mind Open Source Project         http://www.mosp.jp/
 * Copyright (C) 1987-2009 MIND Co., Ltd.  http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.common.action;

import java.util.Date;

import jp.mosp.common.CommonConst;
import jp.mosp.common.MosPAction;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;
import jp.mosp.common.dao.MosPUserDao;
import jp.mosp.common.dto.CmUserDto;
import jp.mosp.common.vo.MosPPasswordVo;

public class MosPPasswordAction extends MosPAction {

	// コマンド
	private static final String CMD_PASSWORD_SHOW   		= "C1050";
	private static final String CMD_PASSWORD_CHANGE 		= "C1051";
	public  static final String CMD_PASSWORD_FORCE_CHANGE = "C1052";

	/**
	 * アクション
	 */
	public void action() throws Exception {
		// VOの取得及び設定
		MosPPasswordVo vo = getInitVo();
		init(vo);
		// コマンド毎の処理
		if (cmd.equals(CMD_PASSWORD_SHOW)) {
			// 表示
			vo.setUserId(user.getUserId());
			vo.setUserName(user.getUserName());
			// メニューへボタンの表示
			vo.setMode(MosPPasswordVo.MODE_SHOW);
		} else if (cmd.equals(CMD_PASSWORD_CHANGE)) {
			// 更新
			update(vo);
			// メニューへボタンの表示
			vo.setMode(MosPPasswordVo.MODE_SHOW);
		} else if (cmd.equals(CMD_PASSWORD_FORCE_CHANGE)) {
			vo.setUserId(user.getUserId());
			vo.setUserName(user.getUserName());
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}
	
	protected MosPPasswordVo getInitVo() {
		return new MosPPasswordVo();
	}
	
	/**
	 * 初期処理
	 * @param vo	対象VO
	 */
	private void init(MosPPasswordVo vo) {
		vo.initVo(cfg, msg, cmd, aspUser, user);
		vo.setParams(request);
		// VO及びフォワード先URLの設定
		setVo(vo);
		setUrl(vo.getRetUrl());
		// メニューコマンド設定
		setCmdMenu(vo);
		// メニューへボタンの非表示設定
		vo.setMode(MosPPasswordVo.MODE_FORCE_UPDATE);
	}

	/**
	 * データ更新
	 * @param vo 対象VO
	 * @throws Exception
	 */
	private void update(MosPPasswordVo vo) throws Exception {
		// コネクションの取得及びDAOの準備
		getConnection();
		MosPUserDao dao = new MosPUserDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// DTOの準備
		CmUserDto dto = dao.findForUpdate(vo.getUserId());
		// 存在確認
		chkExist(dto);
		// パラメータの妥当性確認
		vo.validate(dto.getPassword());
		// 値の設定
		dto.setPassword(MospUtility.encrypt(vo.getHdnNewPassword(), hasMospSeJar()));
		// パスワード変更日時をセットする。
		dto.setChangePass(new Date());
		// データの更新
		dao.update(dto, false);
		// コミット
		commit();
		// メッセージ設定
		vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_UPDATE, ""));
	}

	/**
	 * メニューコマンド設定
	 * @param vo 設定対象VO
	 */
	private void setCmdMenu(MosPPasswordVo vo) {
		if (user.getMospAuthority().equals(CommonConst.AUTH_SYSTEM)) {
			vo.setCmdMenu(vo.CMD_MENU_SYSTEM2);
		} else {
			vo.setCmdMenu(vo.CMD_MENU_INPUT);
		}
	}

}
